
// The Controller is the last MVC made and receives the Model (m) and the View (v)
// The Controller holds all the events and updates the View and the Model when needed

export class Controller { 

    constructor(m, v) {

        // UPDATING PICKER
        // set the events for the three Stepper objects on Horizontal and Vertical pages
        loop(3, i=>{
            const stepperH = v.pageH1["stepper"+(i+1)];
            stepperH.count = i;
            stepperH.change(doStepper);
            const stepperV = v.pageV1["stepper"+(i+1)];
            stepperV.count = i;
            stepperV.change(doStepper);
            // set other so can easily update when event happens
            stepperH.other = stepperV;
            stepperV.other = stepperH;
        });
        function doStepper(e) {
            const stepper = e.target;
            const amount = stepper.currentValue;
            // update other component in case switch orientation
            stepper.other.currentValue = amount;
            // update data and save in case closes app
            m.data[0][stepper.count] = amount;
            m.storeData();
        }

        // UPDATING LIST
        v.pageH2.list.change(doList);
        v.pageH2.list.other = v.pageV2.list;
        v.pageV2.list.change(doList);
        v.pageV2.list.other = v.pageH2.list;
        function doList(e) {
            const amount = e.target.selectedIndex;
            e.target.other.selectedIndex = amount;
            m.data[1] = amount;
            m.storeData();
        }

        // HANDLING NAVIGATION
        // optional handling of all navigation with HotSpots
        // usually can factor out various arrows from page to page like this
        // here we make the icon go to the next page as an example
        const spots = [];
        loop(2, i=>{
            let page = i+1;
            spots.push(
                {page:v["pageH"+page], rect:v["pageH"+page].logo, call:()=>{zgo("https://zimjs.com/mvc.html", "_blank");}},
                {page:v["pageV"+page], rect:v["pageV"+page].logo, call:()=>{zgo("https://zimjs.com/mvc.html", "_blank");}},
                {page:v["pageH"+page], rect:v["pageH"+page].icon, call:()=>{v.pagesH.go(v["pageH"+(page%2+1)], "right")}},
                {page:v["pageV"+page], rect:v["pageV"+page].icon, call:()=>{v.pagesV.go(v["pageV"+(page%2+1)], "down")}}
            );
        })
        new HotSpots(spots);

        // HANDLING ORIENTATION
        function swapPages() {
            if (F.orientation == "vertical") {
                v.pagesH.removeFrom();
                v.pagesV.addTo();
                v.pagesV.go(v.pagesH.index, null, "none");
            } else {
                v.pagesV.removeFrom();
                v.pagesH.addTo();
                v.pagesH.go(v.pagesV.index, null, "none");
            }
        }
        swapPages();
        F.on("orientation", swapPages);
    }

} // end of Controller class
